package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class BgTile2 extends Sprite
	{
		private static const rgb:Number = Math.random();
		private var color1r:uint;
		private var color1g:uint;
		private var color1b:uint;
		private var color2r:uint;
		private var color2g:uint;
		private var color2b:uint;
		private var counter:int;
		private const transformCount:int = 10;
		private const ColorAlpha:Number = 1;
		
		public function BgTile2() 
		{
			//super(false, true);
			var color1:uint = 0x00ffffff * Math.random();
			color1r = color1 >> 16;
			color1g = color1 >> 8 & 0xff;
			color1b = color1 & 0xff;
			color1r = color1r * ColorAlpha;
			color1g = color1g * ColorAlpha;
			color1b = color1b * ColorAlpha;
			var color2:uint = 0x00ffffff * Math.random();
			color2r = color2 >> 16;
			color2g = color2 >> 8 & 0xff;
			color2b = color2 & 0xff;
			color2r = color2r * ColorAlpha;
			color2g = color2g * ColorAlpha;
			color2b = color2b * ColorAlpha;
			/*if (rgb > 0.67)
			{
				color1r = color2r;
				color1g = color2g;
			}
			else if (rgb > 0.33)
			{
				color1g = color2g;
				color1b = color2b;
			}
			else
			{
				color1b = color2b;
				color1r = color2r;
			}*/
			counter = Math.random() * 2 * transformCount;
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function enterFrameHandler(e:Event):void
		{
			counter++;
			var colorRatio:Number = 0
			if (counter < transformCount)
			{
				colorRatio = counter / transformCount;
			}
			else
			{
				colorRatio = (2 * transformCount - counter) / transformCount;
			}
			if (counter >= 2 * transformCount)
			{
				counter = 0;
			}
			colorRatio = colorRatio;
			var r:uint = color1r + (color2r - color1r) * colorRatio;
			var g:uint = color1g + (color2g - color1g) * colorRatio;
			var b:uint = color1b + (color2b - color1b) * colorRatio;
			graphics.clear();
			graphics.beginFill((r<<16 | g<<8 | b), 1);
			graphics.drawRect( -GameBoard.TileWidth / 2, -GameBoard.TileHeight / 2, GameBoard.TileWidth, GameBoard.TileHeight);
			graphics.endFill();
		}
		
		public function destroy():void
		{
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			parent.removeChild(this);
		}
	}

}