package  
{
	import flash.events.Event;
	import flash.geom.Point;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class MonsterDiagonal extends Pprite
	{
		public var direction:Point;
		private const SPEED:Number = 4;
		
		public function MonsterDiagonal() 
		{
			super(false, false);
			setCollisionBox(32, 32);
			friction = 0;
			direction = new Point(1, 1);
			speed.x = direction.x * SPEED;
			speed.y = direction.y * SPEED;
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			GameBoard.monsterDiagonals.addItem(this);
			addSprite(new monsterDiagonal());
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (!isKilled)
			{
				if (GameBoard.instance.powerUpCountDown <= 0)
				{
					alpha = 0.7 + 0.3 * Math.random();
				}
				else
				{
					alpha = 0.3;
				}
				
				if (direction.x == 1)
				{
					if (x + collisionBox.x / 2 + speed.x > GameBoard.NoOfTiles.x * GameBoard.TileWidth)
					{
						direction.x = direction.x * (-1);
					}
				}
				else
				{
					if (x - collisionBox.x / 2 + speed.x < 0)
					{
						direction.x = direction.x * (-1);
					}
				}
				if (direction.y == 1)
				{
					if (y + collisionBox.y / 2 + speed.y > GameBoard.NoOfTiles.y * GameBoard.TileHeight)
					{
						direction.y = direction.y * (-1);
					}
				}
				else
				{
					if (y - collisionBox.y / 2 + speed.y < 0)
					{
						direction.y = direction.y * (-1);
					}
				}
				speed.x = direction.x * SPEED;
				speed.y = direction.y * SPEED;
			}
			else
			{
				if (scaleX > 0)
				{
					scaleX = scaleY = scaleX - 0.1;
				}
				else
				{
					destroy();
				}
			}
		}
		
		public override function destroy():void
		{
			GameBoard.monsterDiagonals.removeItem(this);
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			super.destroy();
		}
	}

}