package  
{
	import flash.display.Sprite;
	import flash.geom.Point;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class Pprite extends Sprite
	{
		public var isStatic:Boolean;
		public var isSolid:Boolean;
		public var speed:Point;
		public var collisionBox:Point;
		public var friction:Number;
		public var sprite:Sprite;
		public var isPlayer:Boolean;
		public var isMonster:Boolean;
		public var isKilled:Boolean;
		
		public function Pprite(_isSolid:Boolean, _isStatic:Boolean = true) 
		{
			isStatic = _isStatic;
			isSolid = _isSolid;
			speed = new Point();
			collisionBox = new Point();
			friction = 0.1;
			
			if (isSolid)
			{
				PhysicsHandler.solidObjects.addItem(this);
			}
			else
			{
				PhysicsHandler.nonsolidObjects.addItem(this);
			}
		}
		
		public function setCollisionBox(_x:Number, _y:Number):void
		{
			collisionBox.x = _x;
			collisionBox.y = _y;
		}
		
		public function destroy():void
		{
			if (isSolid)
			{
				PhysicsHandler.solidObjects.removeItem(this);
			}
			else
			{
				PhysicsHandler.nonsolidObjects.removeItem(this);
			}
			parent.removeChild(this);
		}
		
		public function colorCollisionBox(_color:uint):void
		{
			graphics.clear();
			graphics.beginFill(_color, 1);
			graphics.drawRect(-collisionBox.x / 2, -collisionBox.y / 2, collisionBox.x, collisionBox.y);
			graphics.endFill();
		}
		
		public function addSprite(_sprite:Sprite):void
		{
			sprite = _sprite;
			addChild(sprite);
		}
	}

}