package  
{
	import flash.events.Event;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class LockedDoor extends Pprite
	{
		public var id:int;
		public var color:uint;
		
		public function LockedDoor(_id:int) 
		{
			super(true, true);
			id = _id;
			GameBoard.lockedDoors.addItem(this);
			setCollisionBox(GameBoard.TileWidth - 4, GameBoard.TileHeight - 4);
			if (id == 5)
			{
				color = 0xff0000;
			}
			else if (id == 4)
			{
				color = 0x00ff00;
			}
			else if (id == 3)
			{
				color = 0x0000ff;
			}
			else if (id == 2)
			{
				color = 0xaa00aa;
			}
			else if (id == 1)
			{
				color = 0x00aaaa;
			}
			else if (id == 0)
			{
				color = 0xaaaa00;
			}
			colorCollisionBox(color);
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			addSprite(new lockedDoor());
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (isKilled)
			{
				if (scaleX > 0)
				{
					scaleX = scaleY = scaleX - 0.1;
				}
				else
				{
					destroy();
				}
			}
		}
		
		public override function destroy():void
		{
			GameBoard.lockedDoors.removeItem(this);
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			super.destroy();
		}
	}

}