package  
{
	import flash.geom.Point;
	import flash.events.Event;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class Monster extends Pprite
	{
		public var direction:Point;
		private const SPEED:Number = 2;
		
		public function Monster() 
		{
			super(true, false);
			setCollisionBox(32, 32);
			friction = 0;
			direction = new Point(-1, 0);
			speed.x = direction.x * SPEED;
			speed.y = direction.y * SPEED;
			isMonster = true;
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			addSprite(new monster());
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (!isKilled)
			{
				if (GameBoard.instance.powerUpCountDown <= 0)
				{
					alpha = 0.7 + 0.3 * Math.random();
				}
				else
				{
					alpha = 0.3;
				}
				
				if (speed.x == 0 && speed.y == 0)
				{
					if (direction.x == -1)
					{
						direction.x = 0;
						direction.y = 1;
					}
					else if (direction.y == -1)
					{
						direction.x = -1;
						direction.y = 0;
					}
					else if (direction.x == 1)
					{
						direction.x = 0;
						direction.y = -1;
					}
					else if (direction.y == 1)
					{
						direction.x = 1;
						direction.y = 0;
					}
					speed.x = direction.x * SPEED;
					speed.y = direction.y * SPEED;
				}
			}
			else
			{
				if (scaleX > 0)
				{
					scaleX = scaleY = scaleX - 0.1;
				}
				else
				{
					destroy();
				}
			}
			sprite.rotation = Math.atan2(speed.y, speed.x) * 180 / Math.PI;
		}
		
		public override function destroy():void
		{
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			super.destroy();
		}
	}

}