package  
{
	import flash.events.Event;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class MonsterLeftRight extends Pprite
	{
		public var isRight:Boolean;
		private const SPEED:Number = 2;
		
		public function MonsterLeftRight() 
		{
			super(true, false);
			setCollisionBox(32, 32);
			friction = 0;
			speed.x = - SPEED;
			isMonster = true;
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			addSprite(new monsterLeftRight());
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (!isKilled)
			{
				if (GameBoard.instance.powerUpCountDown <= 0)
				{
					alpha = 0.7 + 0.3 * Math.random();
				}
				else
				{
					alpha = 0.3;
				}
				
				if (speed.x == 0 && speed.y == 0)
				{
					isRight = !isRight;
					if (isRight)
					{
						speed.x = SPEED;
					}
					else
					{
						speed.x = -SPEED;
					}
				}
			}
			else
			{
				if (scaleX > 0)
				{
					scaleX = scaleY = scaleX - 0.1;
				}
				else
				{
					destroy();
				}
			}
		}
		
		public override function destroy():void
		{
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			super.destroy();
		}
	}

}